/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


/************************************************************
 * project=tweety                                           *
 * codename=kleiner eibnet/ip server                        *
 * version=1.1                                              *
 ************************************************************/

/**
 * @file cemi.h
 *
 * This file contains cEMI packet definitions.
 *
 * @date created 16.05.05,
 *       last modified 02.09.05
 *
 * @author bernhard erb
 *         bernhard.erb@gmx.net
 *
 */

/*
 * ********************************************** defines ***
 */

/*
 * ************************ CEMI Message Codes ***
 */
#ifndef CEMI_H
#define CEMI_H

#define	L_BUSMON_IND		0x2B
#define	L_RAW_IND			0x2D
#define	L_RAW_REQ			0x10
#define	L_RAW_CON			0x2F
#define	L_DATA_REQ			0x11
#define	L_DATA_CON			0x2E
#define	L_DATA_IND			0x29
#define	L_POLL_DATA_REQ	0x13
#define	L_POLL_DATA_CON	0x25
#define	M_PROP_READ_REQ	0xFC
#define	M_PROP_READ_CON	0xFB
#define	M_PROP_WRITE_REQ	0xF6
#define	M_PROP_WRITE_CON	0xF5
#define	M_PROP_INFO_IND	0xF7
#define	M_RESET_REQ			0xF1
#define	M_RESET_IND			0xF0

/*
 * ************************************ typedefinition ***
 */

typedef unsigned char byte;
typedef unsigned short word;


typedef struct {
    byte mc;
    byte ioth;
    byte iotl;
    byte oi;
    byte pid;
    word noe_six;
    byte *data;
} CEMI_MGMT_MESSAGE;

typedef struct {
    byte mc;
    byte addil;
    byte ctrl1;
    byte ctrl2;
    word saddr;
    word daddr;
    byte apci_length;
    byte apci;
} CEMI_L_DATA_MESSAGE;

typedef struct {
    byte mc;
    byte ctrl1;
    word saddr;			/*if message is a CON or REQ message this field is unused */
    word daddr;
    byte ctrl2;
    byte npdu;
} EMI_L_DATA_MESSAGE;

typedef struct {
    byte m_code;
    byte status;
    word timestamp;
    byte cfield;
    byte saddr;
    byte saddr1;
    byte daddr;
    byte daddr2;
    byte length;
    byte acpicontr;
} EMI_L_BUSMON_IND;

typedef struct {
    byte mc;
    byte length;
    word address;
} PC_GET_MESSAGE;

#endif

/*
 * *************************************************** EOF ***
 */
